Bus Pass HDU

来源:互联网 发布:好看的美剧 知乎 编辑:程序博客网 时间:2024/06/05 15:39

You travel a lot by bus and the costs of all the seperate tickets are starting to add up. 

Therefore you want to see if it might be advantageous for you to buy a bus pass. 

The way the bus system works in your country (and also in the Netherlands) is as follows: 

when you buy a bus pass, you have to indicate a center zone and a star value. You are allowed to travel freely in any zone which has a distance to your center zone which is less than your star value. For example, if you have a star value of one, you can only travel in your center zone. If you have a star value of two, you can also travel in all adjacent zones, et cetera. 

You have a list of all bus trips you frequently make, and would like to determine the minimum star value you need to make all these trips using your buss pass. But this is not always an easy task. For example look at the following figure: 



Here you want to be able to travel from A to B and from B to D. The best center zone is 7400, for which you only need a star value of 4. Note that you do not even visit this zone on your trips! 


题目大意: 共有m个地区 和n条公交线路 求距离所有公交站最近的那块区域

思路:对每个点来次BFS, 找到该点到公交车站最远的距离, 加入数组。 再找到数组里最小的那个数就好了

#include <iostream>#include <cstring>#include <queue>using namespace std;const int N = 1e4+6;int nz, nr;int zone[N], map[N][20];bool vis[N];int step[N];void bfs(int s) {memset(vis, 0, sizeof(vis));queue<int> q;q.push(s);vis[s] = 1;step[s] = 1;while (!q.empty()) {s = q.front(); q.pop();for (int i = 0; i < zone[s]; i++) {int temp = map[s][i];if (!vis[temp]) {vis[temp] = 1;step[temp] = step[s] + 1;q.push(temp);}}}}int main(void) {int t;cin >> t;while (t--) {cin >> nz >> nr;for (int i = 0; i < nz; i++) {int id, mz;cin >> id >> mz;zone[id] = mz;for (int j = 0; j < mz; j++) {int mzi;cin >> mzi;map[id][j] = mzi;}}int ans[N] = {0};memset(step, 0, sizeof(step));for (int i = 0; i < nr; i++) {int m;cin >> m;for (int j = 0; j < m; j++) {int s;cin >> s;bfs(s);for (int k = 0; k < N; k++) {ans[k] = max(ans[k], step[k]);}}}int star = 0x3f3f3f3f, ceter;for (int i = 0; i < N; i++) {if (ans[i] && ans[i] < star) {star = ans[i];ceter = i;}}cout << star << " " << ceter << endl;}return 0;} 


原创粉丝点击